﻿using Infragistics.Windows;
using Infragistics.Windows.DataPresenter;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XDGClearButtonTest
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ViewModel vm = new ViewModel();
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = vm;
        }

        private void clearCellsBtn_Click(object sender, RoutedEventArgs e)
        {
            Button button = sender as Button;
            CellValuePresenter cvp = GetCVP(button);

            if(cvp != null)
            {
                DataRecord record = cvp.Record as DataRecord;

                if(record != null)
                {
                    foreach(Cell cell in record.Cells)
                    {
                        cell.Value = null;
                    }
                }
            }
        }

        private void clearDataItemBtn_Click(object sender, RoutedEventArgs e)
        {
            Button button = sender as Button;
            CellValuePresenter cvp = GetCVP(button);

            if (cvp != null)
            {
                SampleData data = GetDataItem(cvp);
                data.ID = null;
                data.Name = string.Empty;
                data.Number = null;
            }
        }

        private CellValuePresenter GetCVP(Button button)
        {
            CellValuePresenter cvp = Utilities.GetAncestorFromType(button, typeof(CellValuePresenter), false) as CellValuePresenter;
            return cvp;            
        }

        private SampleData GetDataItem(CellValuePresenter cvp)
        {
            DataRecord record = cvp.Record as DataRecord;
            if(record != null)
            {
                return record.DataItem as SampleData;
            }
            else
            {
                return null;
            }
        }

        Random r = new Random();
        private void invalidateBtn_Click(object sender, RoutedEventArgs e)
        {
            DataRecord record = xdg1.Records[r.Next(xdg1.Records.Count)] as DataRecord;

            if(record != null)
            {
                SampleData sd = record.DataItem as SampleData;
                sd.IsInvalid = !sd.IsInvalid;
            }
        }
    }
}
