﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;

namespace XDGClearButtonTest
{
    public class ViewModel
    {
        public ObservableCollection<SampleData> Data { get; set; }

        public List<string> ComboData { get; set; }

        string[] names = "Andrew;Jen;Tom;Liz;Eric;Steve;Pam;Valerie".Split(';');
        Random r = new Random();
        public ViewModel()
        {
            Data = new ObservableCollection<SampleData>();

            for(int i=0; i<names.Length; i++)
            {
                Data.Add(new SampleData()
                {
                    ID = i,
                    Name = names[i],
                    Number = r.Next(1000),
                    IsInvalid = false
                });
            }

            ComboData = names.ToList();
        }
    }

    public class SampleData : INotifyPropertyChanged
    {
        private int? _id;
        private string _name;
        private int? _num;
        private bool _invalid;

        public int? ID
        {
            get { return _id; }
            set
            {
                if(_id != value)
                {
                    _id = value;
                    OnPropertyChanged();
                }
            }
        }

        public string Name
        {
            get { return _name; }
            set
            {
                if(_name != value)
                {
                    _name = value;
                    OnPropertyChanged();
                }
            }
        }
        public int? Number
        {
            get { return _num; }
            set
            {
                if(_num != value)
                {
                    _num = value;
                    OnPropertyChanged();
                }
            }
        }

        public bool IsInvalid
        {
            get { return _invalid; }
            set
            {
                if(_invalid != value)
                {
                    _invalid = value;
                    OnPropertyChanged();
                }
            }
        }                        

        public event PropertyChangedEventHandler PropertyChanged;

        // This method is called by the Set accessor of each property.
        // The CallerMemberName attribute that is applied to the optional propertyName
        // parameter causes the property name of the caller to be substituted as an argument.
        public void OnPropertyChanged([CallerMemberName] String propertyName = "")
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
}
